function [ mu, W, lambda, X ] = pca( X, k, opts )
%PCA Find k prinicpal componens of X

    if nargin < 3
        opts = struct();
    end

    % Center X
    mu = mean(X);
    X = X - repmat(mu, size(X,1), 1);
    
    % Compute principal components using SVD
    [~,S,W] = svds(X, k, 'L', opts);
    lambda = diag(S);

end

