

load data/digits.mat;


%I = y_train == 3;
I = ismember(y_train, [1 2 3 4 5 6 7 8 9 10]);
X_orig = X_train(I,:);
m = size(X_train,1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Run PCA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k = 100;
[mu, W_all, lambda, X] = pca(X_orig, k);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Visualize principal components
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1);
clf();
n_display = 25;
display_data(W_all(:,1:n_display)');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Display reconstructions for increasing k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(2);
clf();

for i=1:k

    W = W_all(:,1:i);
    
    % To compress: X*W
    X_compressed = X*W; 
    
    % To restore: X ~ X*W*W'
    %   - If absolute values of the features matter, you also need to 
    %     add mu to "uncenter" the data
    X_restored = X_compressed*W' + repmat(mu, m, 1);

    n_display = 25;
    
    figure(2);
    subplot(1,2,1);   
    display_data(X_orig(1:n_display,:));
    set(gca, 'fontsize', 20);
    title(sprintf('Original', i));

    subplot(1,2,2);
    display_data(X_restored(1:n_display,:));
    set(gca, 'fontsize', 20);
    title(sprintf('Restored: k=%d', i));
    
    pause;
    
end
