function pca_gui(X)
%PCA_GUI Simple PCA gui

[mu, W] = pca(X, 1);

f = figure('Visible', 'off', 'Position',[360,600,800,300]);

sld = uicontrol('Style', 'slider',...
    'Min',-2,'Max',2,'Value',0,...
    'Units', 'Normalized', ...
    'Position', [0.4, 0.0, 0.3, 0.1], ...
    'Callback', @sliderchange);

hLstn = handle.listener(sld,'ActionEvent',@sliderchange); %#ok<NASGU>

colormap(gray)

subplot('position', [0.1 0.2 0.25 0.65]);
set(gca, 'fontsize', 20);
imagesc(reshape(mu, 20, 20), [0 1]);
title('Mean \mu')

subplot('position', [0.4 0.2 0.25 0.65]);
set(gca, 'fontsize', 20);
imagesc(reshape(W(:,1), 20, 20), [-0.2 0.2]);
title('w_1');

subplot('position', [0.7 0.2 0.25 0.65]);
set(gca, 'fontsize', 20);
imagesc(reshape(mu, 20, 20), [0 1]);
title('\mu + a w_1');

set(f, 'Visible', 'on');
    function sliderchange(source, ~)
        alpha = get(source, 'Value');
        im = mu + alpha*W(:,1)';
        imagesc(reshape(im, 20, 20), [0 1]);
        title('\mu + a w_1');
    end

end
